#include "descriptor/descriptor.h"

#define NUMHPIL 6
#define NUMVPIL 14

#define NUMPIL 38
#define NUMCOL NUMPIL*3

#define NUMSCALINI 4

int main(void) {

  int i;
  char tmp[100];

  ITEM	glass,ceramic,brown,yellow,blu,text_col,text_pav;
  ITEM	colonna[NUMCOL],testacolonna[NUMPIL],bloccocolonna[NUMPIL],pavimento[NUMSCALINI];
  ITEM  bloccosuperiore[4],collina,cupola[2];
  ITEM	scene;

  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "light1");
  create_point_light(12,-12,9,1,1,1,4,20, "light2");
  create_point_light(2.33,-0.25,16.21,1,1,1,3.89,25, "light3");

  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.68,0.86,1,0.5,0.5);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.87,0.68,1,1.2);

  /*** ATTRIBUTE ceramic ***/
  ceramic = create_attribute("ceramic");
  set_color(ceramic,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(ceramic,0.2,128);

  /*** ATTRIBUTE text_col ***/
  text_col = create_attribute("texture");
  set_color(text_col,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(text_col,0.2,128);

  /*** ATTRIBUTE text_pav ***/
  text_pav = create_attribute("texture2");
  set_color(text_pav,0.89,0.76,0.65,0.1,0.8);
  set_reflectivity(text_pav,0.2,128);

  /*** ATTRIBUTE brown ***/
  brown = create_attribute("brown");
  set_color(brown,0.93,0.53,0.6,0.12,0.8);
  set_reflectivity(brown,0.17,120);

  /*** ATTRIBUTE yellow ***/
  yellow = create_attribute("yellow");
  set_color(yellow,1,1,0,0.2,0.8);
  set_reflectivity(yellow,0.3,10);

  /*** ATTRIBUTE blu ***/
  blu = create_attribute("blu");
  set_color(blu,0,0,1,0.5,0.5);
  set_reflectivity(blu,0.3,10);

  pavimento[0] = read_nurbs("cube1.db");

  for(i=1;i<NUMSCALINI;i++)
  {
	  sprintf(tmp,"pavimento_%d",i);
	  pavimento[i] = create_copy(pavimento[0], tmp);
	  set_scale(pavimento[i],1+i*0.02,1+i*0.02,1);
  }


  for(i=0;i<NUMSCALINI;i++)
  {
	  set_scale(pavimento[i],3,7,0.1);
	  set_translate(pavimento[i],2.5,6.5,-0.55);
  }

  for(i=1;i<NUMSCALINI;i++)
  {
	  set_translate(pavimento[i],0,0,-0.22*i);
  }

  colonna[0] = read_nurbs("terzocolonna.db");


  for(i=1;i<NUMCOL;i++)
  {
	  sprintf(tmp,"colonna_%d",i);
	  colonna[i] = create_copy(colonna[0], tmp);
  }

  for(i=1;i<NUMCOL;i++)
  {
	  sprintf(tmp,"colonna_%d",i);
	  colonna[i] = create_copy(colonna[0], tmp);
  }

  testacolonna[0]=read_nurbs("testacolonna.db");
  set_scale(testacolonna[0],0.8,0.8,0.8);
  set_translate(testacolonna[0],0,0,1.746);
  set_projection_texture(testacolonna[0],text_col,"textures/rock1.hr",1,1,0.6,0.5);

  collina=read_nurbs("base.db");
  set_scale(collina,20,38,20);
  set_z_rotate(collina,180,1);
  set_translate(collina,5,6.5,-0.1);
  set_projection_texture(collina,text_col,"textures/piante.hr",2,1,0.6,0.5);

  cupola[0]=read_obj("cupola.obj","cupola triangolare");
  set_scale(cupola[0],3.11,0.583,2);
  set_translate(cupola[0],2.5,-0.29,2.49);
  set_x_rotate(cupola[0],45,1);
  set_y_rotate(cupola[0],45,1);
  set_z_rotate(cupola[0],45,1);
  set_projection_texture(cupola[0],text_col,"textures/rock1.hr",1,1,0.5,0.6);
  set_z_rotate(cupola[0],-45,1);
  set_y_rotate(cupola[0],-45,1);
  set_x_rotate(cupola[0],-45,1);

  cupola[1]=read_obj("cupola.obj","cupola triangolare2");
  set_scale(cupola[1],3.11,0.74,2);
  set_z_rotate(cupola[1],180,1);
  set_translate(cupola[1],2.5,-0.29,2.49);
  set_translate(cupola[1],0,13.6,0);
  set_x_rotate(cupola[1],45,1);
  set_y_rotate(cupola[1],45,1);
  set_z_rotate(cupola[1],45,1);
  set_projection_texture(cupola[1],text_col,"textures/rock1.hr",1,1,0.5,0.6);
  set_z_rotate(cupola[1],-45,1);
  set_y_rotate(cupola[1],-45,1);
  set_x_rotate(cupola[1],-45,1);


  bloccocolonna[0]=read_nurbs("cube.db");
  set_scale(bloccocolonna[0],0.3,0.3,0.05);
  set_translate(bloccocolonna[0],0,0,1.792);
  set_x_rotate(bloccocolonna[0],45,1);
  set_y_rotate(bloccocolonna[0],45,1);
  set_z_rotate(bloccocolonna[0],45,1);
  set_projection_texture(bloccocolonna[0],text_col,"textures/rock1.hr",1,1,0.6,0.5);
  set_z_rotate(bloccocolonna[0],-45,1);
  set_y_rotate(bloccocolonna[0],-45,1);
  set_x_rotate(bloccocolonna[0],-45,1);

  bloccosuperiore[0]=read_nurbs("cube.db");
  set_scale(bloccosuperiore[0],2.8,0.3,0.32);
  set_translate(bloccosuperiore[0],2.5,0,2.166);
  set_x_rotate(bloccosuperiore[0],45,1);
  set_y_rotate(bloccosuperiore[0],45,1);
  set_z_rotate(bloccosuperiore[0],45,1);
  set_projection_texture(bloccosuperiore[0],text_col,"textures/rock1.hr",1,1,0.6,0.5);
  set_z_rotate(bloccosuperiore[0],-45,1);
  set_y_rotate(bloccosuperiore[0],-45,1);
  set_x_rotate(bloccosuperiore[0],-45,1);

  bloccosuperiore[1]=create_copy(bloccosuperiore[0],"blocco2");
  set_translate(bloccosuperiore[1],0,13,0);

  bloccosuperiore[2]=read_nurbs("cube.db");
  set_scale(bloccosuperiore[2],0.3,6.8,0.32);
  set_translate(bloccosuperiore[2],0,6.5,2.166);
  set_x_rotate(bloccosuperiore[2],45,1);
  set_y_rotate(bloccosuperiore[2],45,1);
  set_z_rotate(bloccosuperiore[2],45,1);
  set_projection_texture(bloccosuperiore[2],text_col,"textures/rock1.hr",1,1,0.6,0.5);
  set_z_rotate(bloccosuperiore[2],-45,1);
  set_y_rotate(bloccosuperiore[2],-45,1);
  set_x_rotate(bloccosuperiore[2],-45,1);

  bloccosuperiore[3]=create_copy(bloccosuperiore[2],"blocco4");
  set_translate(bloccosuperiore[3],5,0,0);


  for(i=0;i<NUMPIL;i++)
  {
	  bloccocolonna[i] = create_copy(bloccocolonna[0], tmp);
	  testacolonna[i] = create_copy(testacolonna[0], tmp);
	  set_z_rotate(testacolonna[i],rand()%360,1);
	  set_z_rotate(testacolonna[i],rand()%360,1);
  }


  for(i=0;i<NUMCOL;i++)
  {
	  set_projection_texture(colonna[i],text_col,"textures/rock1.hr",1,1,0.6,0.5);
	  set_z_rotate(colonna[i],rand()%360,1);
  }

  for(i=0;i<NUMSCALINI;i++)
  {
	  set_scale(pavimento[i],1/3.0,1/3.0,1/3.0);
	  set_projection_texture(pavimento[i],text_pav,"textures/america.hr",2,1,0.4,0.3);
	  set_scale(pavimento[i],3,3,3);
  }

  for(i=0;i<NUMPIL;i++)
	  {
	   set_scale(colonna[i+NUMPIL],0.86,0.86,0.86);
	   set_translate(colonna[i+NUMPIL],0,0,0.738);
	  }

  for(i=0;i<NUMPIL;i++)
	  {
	   set_scale(colonna[i+NUMPIL*2],0.73,0.73,0.73);
	   set_translate(colonna[i+NUMPIL*2],0,0,1.373);
	  }

  for(i=1;i<NUMHPIL;i++)
  {
	  set_translate(bloccocolonna[i         ],1*i,0,0);
	  set_translate(testacolonna[i         ],1*i,0,0);
	  set_translate(colonna[i         ],1*i,0,0);
	  set_translate(colonna[i+NUMPIL  ],1*i,0,0);
	  set_translate(colonna[i+NUMPIL*2],1*i,0,0);
  }

  for(i=1;i<NUMVPIL;i++)
  {
	  set_translate(bloccocolonna[i+NUMHPIL-1         ],0,1*i,0);
	  set_translate(testacolonna[i+NUMHPIL-1         ],0,1*i,0);
	  set_translate(colonna[i+NUMHPIL-1         ],0,1*i,0);
	  set_translate(colonna[i+NUMHPIL-1+NUMPIL  ],0,1*i,0);
	  set_translate(colonna[i+NUMHPIL-1+NUMPIL*2],0,1*i,0);
  }

  for(i=1;i<NUMHPIL;i++)
  {
	  set_translate(testacolonna[i+NUMHPIL+NUMVPIL-2      ],1*i,NUMVPIL-1,0);
	  set_translate(bloccocolonna[i+NUMHPIL+NUMVPIL-2      ],1*i,NUMVPIL-1,0);
	  set_translate(colonna[i+NUMHPIL+NUMVPIL-2      ],1*i,NUMVPIL-1,0);
	  set_translate(colonna[i+NUMHPIL+NUMVPIL-2+NUMPIL  ],1*i,NUMVPIL-1,0);
	  set_translate(colonna[i+NUMHPIL+NUMVPIL-2+NUMPIL*2],1*i,NUMVPIL-1,0);
  }

  for(i=1;i<NUMVPIL;i++)
  {
	  set_translate(bloccocolonna[i+NUMHPIL*2+NUMVPIL-3         ],NUMHPIL-1,1*i,0);
	  set_translate(testacolonna[i+NUMHPIL*2+NUMVPIL-3         ],NUMHPIL-1,1*i,0);
	  set_translate(colonna[i+NUMHPIL*2+NUMVPIL-3         ],NUMHPIL-1,1*i,0);
	  set_translate(colonna[i+NUMHPIL*2+NUMVPIL-3+NUMPIL  ],NUMHPIL-1,1*i,0);
	  set_translate(colonna[i+NUMHPIL*2+NUMVPIL-3+NUMPIL*2],NUMHPIL-1,1*i,0);
  }

  scene = create_list(colonna[0], "scene");

  scene = insert_in_list(scene,collina);

  scene = insert_in_list(scene,cupola[0]);
  scene = insert_in_list(scene,cupola[1]);


  for(i=0;i<4;i++)
  scene = insert_in_list(scene,bloccosuperiore[i]);

  for(i=0;i<NUMPIL;i++)
  {
	  scene = insert_in_list(scene,bloccocolonna[i]);
	  scene = insert_in_list(scene,testacolonna[i]);
  }
  for(i=1;i<NUMCOL;i++)
    scene = insert_in_list(scene,colonna[i]);
  for(i=0;i<NUMSCALINI;i++)
    scene = insert_in_list(scene,pavimento[i]);
  save_scene("temple.md","scene_temple",scene);

  return(0);
}
